import Ciudades;
import Tramos;
class Grafo{
	private Ciudades ciud;
	private Tramos tram;
	
	public Grafo(){
		ciud = new Ciudades();
		tram = new Tramos();
	}

	public int  entreGrado(String city){
		int arcAdy = 0, aux;
		aux = ciud.existe(city);
		if(aux == 0)return aux;		// No encontr ciudad buscada
		for (int i=0; i<ciud.getCuantas(); i++)
			if(tram.adyacent(i,aux))arcAdy++;
		return arcAdy;
	}
	
	public int fueraDeGrado(String city){
		int arcAdy = 0;
		int aux = ciud.existe(city);
		if(aux == 0)return aux;		// No encontr ciudad buscada
		for (int i=0; i<ciud.getCuantas(); i++)
			if(tram.adyacent(aux,i))arcAdy++;
		return arcAdy;
	}

	public String toString(){
		String aux = "";
		aux+=ciud.toString();
		aux+=tram.toString();
		return aux;
	}

	public void unir(String desde, String hasta, int distan){
		int des=ciud.existe(desde);
		int has=ciud.existe(hasta);
		if (des != 0 && has != 0)	// Si ambas existen
			tram.unir(des,has,distan);
	}

	public void separar(String desde, String hasta, int distan){
		int des=ciud.existe(desde);
		int has=ciud.existe(hasta);
		if (des != 0 && has != 0)	// Si ambas existen
			tram.separar(des,has);
	}

	public boolean findPath(String desde, String hasta, int tramos){
		int des=ciud.existe(desde);
		int has=ciud.existe(hasta);
		if (des == 0 || has == 0)	// Si ningua existe
			return false;
		return hayCamino(des, has, tramos);
	}

	private boolean hayCamino(int des, int has, int tramos){
		if(tramos == 1) return tram.adyacent(des, has);
		else{
			for(int i=1;i<ciud.getCuantas();i++)
				if(tram.adyacent(des,i) && hayCamino(i, has, tramos - 1))
					return true;
		}	//  else		
		// Si existe adyacencia entre origen y un dest. intermedio y ademas
		// hay un camino de t-1 tramos desde dest. inter. al dest. final
		// Entonces tenemos el camino de t tramos pedido.
		return false;
	}
	
	public void demo(){
		boolean exist;
		System.out.println("\nConectando Tio Pujio a Ballesteros, 35 kms");
		unir("Tio Pujio","Ballesteros",35);
		System.out.println("El entreGrado de Villa Maria es "+entreGrado("Villa Maria"));
		System.out.println("y su fueraDeGrado es .  .  .  . "+fueraDeGrado("Villa Maria"));
		System.out.println("\nBuscando caminos de k tramos ...");
		System.out.println("De Villa Nueva a Villa Maria");
		for(int k = 1;k<8;k++){
			exist = findPath("Villa Nueva","Villa Maria",k);
			if(exist)System.out.print(k+" si, ");
			else     System.out.print(k+" no, ");
		}
		System.out.println("\nDe Villa Maria a Villa Nueva");
		for(int k = 1;k<8;k++){
			exist = findPath("Villa Maria","Villa Nueva",k);
			if(exist)System.out.print(k+" si, ");
			else     System.out.print(k+" no, ");
		}
		System.out.println("\nAusonia a Arroyo Cabral");
		for(int k = 1;k<8;k++){
			exist = findPath("Ausonia","Arroyo Cabral",k);
			if(exist)System.out.print(k+" si, ");
			else     System.out.print(k+" no, ");
		}
		System.out.println("\n");
	}
		
	public static void main(String args[]){
		Grafo grafo = new Grafo();
		grafo.demo();
	}
}




		
